function [z_cNext] = UpdateZ_c(z_c, dU,q, q_min, q_max,IsSaturated)
% This function correspond to Algorithm 3

if IsSaturated
    z_cNext = z_c - dU;   
else
    z_cNext = z_c +1;
end

if q <= q_min
        z_cNext = z_c + 1;
elseif q >= q_max
        z_cNext = z_c - 1;
end     

% Prevent nummerical difficulties 
if z_cNext > 100
    z_cNext = 100;
elseif z_cNext < 0
    z_cNext = 0;
end


end

