function [fNext, IsSaturated] = UpdateF_ESP(f, dU, q, q_min, q_max)
% This function correspond to Algorithm 3

fNext = f - dU;    

if fNext > 65
    fNext = 65;
elseif fNext < 35
    fNext = 35;
end

if q_min <= q && q <= q_max
    IsSaturated = 0;
else
    IsSaturated = 1;
    fNext = f;
end

end

