function [ dp ] = dpBP(f)
%DPBP Summary of this function goes here
%   Detailed explanation goes here
f_0 = 50;                   % [Hz] Pump frequency
H_0 = 2.5*1.0963*10^3;      % [H] Pump head
g = 9.81;                   % [kgm/s^2] Gravitational acceleration
rho = 984;                  % [kg/m^3] Density

H = H_0*(f/f_0)^2;
dp = H*rho*g;


end

