function [ P ] = FlowProfile( P )
% This function updates the well flow profile

P.q_r = P.PI*(P.p(1) - P.x(1));
P.q_c = P.k*ChokeCharacteristics(P.z_c)*sign(P.x(2)-P.p(6))*sqrt(abs(P.x(2)-P.p(6)));
P.q_p = P.x(3);

if P.q_p < 0
    P.q_p = 0;
end


end

